			$mod51
			LOAD EQU P1.2
			DIN EQU P1.1
			CLK EQU P1.0
			KEYPAD EQU P2
			K_A EQU P2.0
			K_B EQU P2.1
			K_C EQU P2.2
			K_D EQU P2.3
			K_P EQU P2.4
		
MAIN:		ACALL INIT
		MOV DPTR,#TABLE
		MOV	R4,#224 
NEXTC:		MOV	R3,#8 			

REPEAT:		MOV R1,#0
			MOV R0,#1
NEXT:		
			MOV A,R0
		
			ACALL SEND_A
			MOV A,R1
			MOVC A,@A+DPTR
		
			ACALL SEND_D
			INC R1
			INC R0
			aCALL DELAY
			MOV P2,#0FFH
			CJNE R1,#8,NEXT
		
			DJNZ	R3, REPEAT
			INC	DPTR
			DJNZ R4, NEXTC
			SJMP MAIN			
INIT:		 ;SHUT DOWN SETTING		
			MOV A,#0CH	
			ACALL SEND_A
			MOV A,#01h
			ACALL SEND_D
			; DISPLAY TEST
			MOV A,#0FFH
			ACALL SEND_A
			MOV A,#01H
			ACALL SEND_D
			; DECODE MODE SETTING
			MOV A,#09H
			ACALL SEND_A
			MOV A ,#00H
			ACALL SEND_D
			; SCAN LIMIT
			MOV A,#0BH
			ACALL SEND_A
			MOV A,#07h
			ACALL SEND_D
			; INTENSITY
			MOV A,#0AH
			ACALL SEND_A
			MOV A,#04H
			ACALL SEND_D
			RET
				
SEND_A:		MOV R7,#8
			CLR LOAD
BACK:		CLR CLK
			RLC A
			MOV DIN,C
			SETB CLK
			DJNZ R7,BACK
			CLR CLK
			RET		
SEND_D:		MOV R7,#8
BACK1:		CLR CLK
			RLC A
			MOV DIN,C
			SETB CLK
			DJNZ R7,BACK1
			SETB LOAD
			RET
TABLE:
	
DB	00H,00H,00H,00H,00H,00H,00H,00H
DB	3EH, 48H, 88H, 48H, 3EH, 00H		;A
DB	0FEH, 92H, 92H, 92H, 6CH, 00H		;B
DB	7CH, 82H, 82H, 82H, 44H, 00H		;C
DB	0FEH, 82H, 82H, 44H, 38H, 00H		;D
DB	0FEH, 92H, 92H, 92H, 82H, 00H		;E
DB	0FEH, 90H, 90H, 90H, 80H, 00H		;F
DB	7CH, 82H, 92H, 94H, 5EH, 00H		;G
DB	0FEH, 10H, 10H, 10H, 0FEH, 00H	;H
DB	00H, 82H, 0FEH, 82H, 00H, 00H		;I
DB	04H, 02H, 82H, 0FCH, 80H, 00H		;J
DB	0FEH, 10H, 28H, 44H, 82H, 00H		;K
DB	0FEH, 02H, 02H, 02H, 02H, 00H		;L
DB	0FEH, 40H, 30H, 40H, 0FEH, 00H	;M
DB	0FEH, 20H, 10H, 08H, 0FEH, 00H	;N
DB	7CH, 82H, 82H, 82H, 7CH, 00H		;O
DB	0FEH, 90H, 90H, 90H, 60H, 00H		;P
DB	7CH, 82H, 8AH, 84H, 7AH, 00H		;Q
DB	0FEH, 90H, 98H, 94H, 62H, 00H		;R
DB	64H, 92H, 92H, 92H, 4CH, 00H		;S
DB	80H, 80H, 0FEH, 80H, 80H, 00H		;T
DB	0FCH, 02H, 02H, 02H, 0FCH, 00H	;U
DB	0F8H, 04H, 02H, 04H, 0F8H, 00H	;V
DB	0FCH, 02H, 1CH, 02H, 0FCH, 00H		;W
DB	0C6H, 28H, 10H, 28H, 66H, 00H		;X
DB	0E0H, 10H, 0EH, 10H, 0E0H, 00H	;Y
DB	86H, 8AH, 92H, 0A2H, 0C2H, 00H	;Z
DB	7CH, 8AH, 92H, 0A2H, 7CH, 00H		;0
DB	00H, 42H, 0FEH, 02H, 00H, 00H		;1
DB	42H, 86H, 8AH, 92H, 62H, 00H		;2
DB	84H, 82H, 0A2H, 0D2H, 8CH, 00H		;3


DB	18H, 28H, 48H, 0FEH, 08H, 00H		;4
DB	0E4H, 0A2H, 0A2H, 0A2H, 9CH, 00H		;5
DB	3CH, 52H, 92H, 92H, 0CH, 00H		;6
DB	80H, 8EH, 90H, 0A0H, 0C0H, 00H	;7
DB	6CH, 92H, 92H, 92H, 6CH, 00H		;8
DB	60H, 92H, 92H, 94H, 78H, 00H		;9

DB	00H,00H,00H,00H,00H,00H,00H,00H

;----------------------------
; DELAY                 2mS
;------------------------------

DELAY:
MOV  R6, #4
DL1:
MOV  R7, #249
DJNZ R7, $
DJNZ R6, DL1
RET 
END 
